using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_Bus_WorkOrder_GriddingWO_Map
	/// </summary>
	public partial class T_Bus_WorkOrder_GriddingWO_Map
    {
        public T_Bus_WorkOrder_GriddingWO_Map()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id, string F_WorkOrderId, string F_GWorkOrderId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Bus_WorkOrder_GriddingWO_Map");
            strSql.Append(" where F_Id=@F_Id and F_WorkOrderId=@F_WorkOrderId and F_GWorkOrderId=@F_GWorkOrderId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4),
                    new SqlParameter("@F_WorkOrderId", SqlDbType.VarChar,50),
                    new SqlParameter("@F_GWorkOrderId", SqlDbType.NVarChar,50)          };
            parameters[0].Value = F_Id;
            parameters[1].Value = F_WorkOrderId;
            parameters[2].Value = F_GWorkOrderId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool ExistsByGSWorkOrderId(string F_GWorkOrderId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Bus_WorkOrder_GriddingWO_Map");
            strSql.Append(" where F_GWorkOrderId=@F_GWorkOrderId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_GWorkOrderId", SqlDbType.VarChar,50)
            };
            parameters[0].Value = F_GWorkOrderId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool ExistsByWorkOrderId(string F_WorkOrderId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Bus_WorkOrder_GriddingWO_Map");
            strSql.Append(" where F_WorkOrderId=@F_WorkOrderId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.VarChar,50)
            };
            parameters[0].Value = F_WorkOrderId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Bus_WorkOrder_GriddingWO_Map model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Bus_WorkOrder_GriddingWO_Map(");
            strSql.Append("F_WorkOrderId,F_GWorkOrderId,F_Direction,F_AddTime,uuid,port_password)");
            strSql.Append(" values (");
            strSql.Append("@F_WorkOrderId,@F_GWorkOrderId,@F_Direction,@F_AddTime,@uuid,@port_password)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.VarChar,50),
                    new SqlParameter("@F_GWorkOrderId", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Direction", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AddTime", SqlDbType.DateTime),
                    new SqlParameter("@uuid", SqlDbType.NVarChar,50),
                    new SqlParameter("@port_password", SqlDbType.NVarChar)};
            parameters[0].Value = model.F_WorkOrderId;
            parameters[1].Value = model.F_GWorkOrderId;
            parameters[2].Value = model.F_Direction;
            parameters[3].Value = model.F_AddTime;
            parameters[4].Value = model.uuid;
            parameters[5].Value = model.port_password;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Bus_WorkOrder_GriddingWO_Map model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Bus_WorkOrder_GriddingWO_Map set ");
            strSql.Append("F_Direction=@F_Direction,");
            strSql.Append("F_AddTime=@F_AddTime,");
            strSql.Append("uuid=@uuid,");
            strSql.Append("port_password=@port_password");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Direction", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AddTime", SqlDbType.DateTime),
                    new SqlParameter("@uuid", SqlDbType.NVarChar,50),
                    new SqlParameter("@port_password", SqlDbType.NVarChar),
                    new SqlParameter("@F_Id", SqlDbType.Int,4),
                    new SqlParameter("@F_WorkOrderId", SqlDbType.VarChar,50),
                    new SqlParameter("@F_GWorkOrderId", SqlDbType.NVarChar,50)};
            parameters[0].Value = model.F_Direction;
            parameters[1].Value = model.F_AddTime;
            parameters[2].Value = model.uuid;
            parameters[3].Value = model.port_password;
            parameters[4].Value = model.F_Id;
            parameters[5].Value = model.F_WorkOrderId;
            parameters[6].Value = model.F_GWorkOrderId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_WorkOrder_GriddingWO_Map ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id, string F_WorkOrderId, string F_GWorkOrderId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_WorkOrder_GriddingWO_Map ");
            strSql.Append(" where F_Id=@F_Id and F_WorkOrderId=@F_WorkOrderId and F_GWorkOrderId=@F_GWorkOrderId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4),
                    new SqlParameter("@F_WorkOrderId", SqlDbType.VarChar,50),
                    new SqlParameter("@F_GWorkOrderId", SqlDbType.NVarChar,50)          };
            parameters[0].Value = F_Id;
            parameters[1].Value = F_WorkOrderId;
            parameters[2].Value = F_GWorkOrderId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_WorkOrder_GriddingWO_Map ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_WorkOrder_GriddingWO_Map GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from T_Bus_WorkOrder_GriddingWO_Map ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            CallCenterApi.Model.T_Bus_WorkOrder_GriddingWO_Map model = new CallCenterApi.Model.T_Bus_WorkOrder_GriddingWO_Map();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Bus_WorkOrder_GriddingWO_Map DataRowToModel(DataRow row)
        {
            Model.T_Bus_WorkOrder_GriddingWO_Map model = new Model.T_Bus_WorkOrder_GriddingWO_Map();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_WorkOrderId"] != null && row["F_WorkOrderId"].ToString() != "")
                {
                    model.F_WorkOrderId = row["F_WorkOrderId"].ToString();
                }
                if (row["F_GWorkOrderId"] != null && row["F_GWorkOrderId"].ToString() != "")
                {
                    model.F_GWorkOrderId = row["F_GWorkOrderId"].ToString();
                }
                if (row["F_Direction"] != null && row["F_Direction"].ToString() != "")
                {
                    model.F_Direction = row["F_Direction"].ToString();
                }
                if (row["F_AddTime"] != null && row["F_AddTime"].ToString() != "")
                {
                    model.F_AddTime = DateTime.Parse(row["F_AddTime"].ToString());
                }
                if (row["uuid"] != null && row["uuid"].ToString() != "")
                {
                    model.uuid = row["uuid"].ToString();
                }
                if (row["port_password"] != null && row["port_password"].ToString() != "")
                {
                    model.port_password = row["port_password"].ToString();
                }
            }
            return model;
        }


        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM T_Bus_WorkOrder_GriddingWO_Map ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" * ");
            strSql.Append(" FROM T_Bus_WorkOrder_GriddingWO_Map ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Bus_WorkOrder_GriddingWO_Map ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Bus_WorkOrder_GriddingWO_Map T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  Method
    }
}
